unit Unit1;

{$MODE Delphi}

{ Author and copyright: Holger Vogt 2013 - 2017
  Modified BSD license

  This program is a demo graphical user interface (GUI) to ngspice.dll.
  It is not meant as a 'productive' GUI, it is by no means optimized,
  it does not use the nice object orientation capabilities of Delphi.
  It is just meant to show the interface to ngspice.dll applying
  all the exported and callback functions with simple examples.}

interface

uses
  LCLIntf, LCLType, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, ExtCtrls, Contnrs, dynlibs, StrUtils;

const
  WM_PRMESSAGE = WM_USER + 1;
  WM_ERRMESSAGE = WM_USER + 2;
  WM_REFMESSAGE = WM_USER + 3;
  WM_STATMESSAGE = WM_USER + 4;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button27: TButton;
    Button28: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Button4: TButton;
    Label5: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Label6: TLabel;
    ComboBox1: TComboBox;
    Button8: TButton;
    Button9: TButton;
    ComboBox2: TComboBox;
    Label7: TLabel;
    Button10: TButton;
    OpenDialog1: TOpenDialog;
    Memo3: TMemo;
    Button11: TButton;
    OpenDialog2: TOpenDialog;
    OpenDialog3: TOpenDialog;
    Panel1: TPanel;
    Edit1: TEdit;
    Edit3: TEdit;
    Label8: TLabel;
    Edit4: TEdit;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    ComboBox3: TComboBox;
    Panel2: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    Button15: TButton;
    Button16: TButton;
    Editt: TEdit;
    Button17: TButton;
    Button18: TButton;


    procedure Button19Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure ComboBox3KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button15Click(Sender: TObject);

// To receive this custom Message that is addressed to form1.handle
// you need a message handler.
    procedure OnPrint(var Msg: TMessage); message WM_PRMESSAGE;
    procedure OnErrPrint(var Msg: TMessage); message WM_ERRMESSAGE;
    procedure OnRefPrint(var Msg: TMessage); message WM_REFMESSAGE;
    procedure OnStatPrint(var Msg: TMessage); message WM_STATMESSAGE;
    procedure Button16Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);


  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    PrintList: TStrings;

  end;

type
  {The following are the equivalent Delphi definitions of the
   C structs defined in sharedspice.h. See sharedspice.h for
   more information. }
  pVector_info = ^Vector_info;

  ngcomplex = record
    cxreal: double;
    cximag: double;
  end;

  Vector_info = record
     v_name: PChar;
     v_type: Integer;
     v_flags: Shortint;
     v_realdata: ^double;
     v_compdata: ^ngcomplex;
     v_length: Integer;
  end;


  vecvalues = record
    name: PChar;
    creal: double;
    cimag: double;
    is_scale: boolean;
    is_complex: boolean;
   end;
  pvecvalues = ^vecvalues;
  ppvecvalues = array of pvecvalues;

  pvecvaluesall =  ^vecvaluesall;
  vecvaluesall = record
    vcount: integer;
    vindex: integer;
    vecsa: array of pvecvalues;
  end;


  pvecinfo = ^vecinfo;
  vecinfo = record
    number: integer;
    vecname: PChar;
    is_real: boolean;
    pdvec: Pointer;
    pdvecscale: Pointer;
  end;


  pvecinfoall = ^vecinfoall;
  vecinfoall = record
    vname: PChar;
    vtitle: PChar;
    vdate: PChar;
    vtype: PChar;
    vcount: integer;
    vecs: array of pvecinfo;
  end;


  // for sending a char* array to ngspice.dll
  carray = array of PChar;
  pcarray = ^carray;

  // for receiving a char* array from ngspice.dll
  TPAnsiCharArray = packed array[0..(MaxLongint div SizeOf(PAnsiChar))-1] of
    PAnsiChar;
  PPAnsiCharArray = ^TPAnsiCharArray;

  TThreadFunc = function(Parameter: Pointer): Integer;
  TThreadFunc2 = function(Parameter: Pointer): Integer;

var
  Form1: TForm1;
  ngspice_Init: function(ptrchar: Pointer; ptrstat: Pointer; ptrexit: Pointer;
                ptrdata: Pointer; ptrinitdata: Pointer; ptrnoruns: Pointer; userData: Pointer): integer; cdecl;
  ngspice_Com: function(ms: PChar): Integer; cdecl;
  ngspice_GetVec: function(ms: PChar): pVector_info; cdecl;
  ngspice_SendCirc: function(circarray: pcarray): Integer; cdecl;
  ngspice_GetCurPlot: function(): PChar; cdecl;
  ngspice_GetPlotNames: function(): ppansichararray; cdecl;
  ngspice_GetVecsFromPlot: function(plotname: PChar): ppansichararray; cdecl;
  ngspice_Running: function(): boolean; cdecl;
  ngspice_Init_Sync: function(ptrvsrcval: Pointer; ptrisrcval: Pointer; ptrsync: Pointer; ident: PInteger; userData: Pointer): integer; cdecl;
  ngspice_SetBkpt: function(simtime: double): boolean; cdecl;
  ngspice_GetCMPath: function(ms: PChar): PChar; cdecl;
  StartIni: TMemIniFile;
  Outqueue: TQueue;

  implementation

var
  Hdll: TLibHandle;
  Startpath: String;      // Pfad von ng_start.exe
  will_detach: boolean;   // flag set to request unloading ngspice.dll
  coquit: boolean;        // flag set that 'quit' requires unloading ngspice.dll
  curvinfoall: pvecinfoall; // info on which vectors are actively filled
                            // in the current simulation
  vecgetnumber: integer;  // number of vector to be monitored
  vecgetscaleno: integer;  // number of scale vector to be monitored
  mainthreadid: DWORD;
  is_attached: boolean;

procedure detach(coquit: boolean); forward;
procedure outdata(); forward;

{$R *.lfm}

// callback function
{  Wrapper around function within TForm1 class, which cannot be called directly
   Transfers output from printf, fprintf, fputs to caller
}
function ng_getchar(inp: PChar; ident: integer; userData: Pointer): integer; cdecl;
var
   inp8: PChar;
   form: TForm1;
   sout: PString;
begin
   // remove 'stdout ', 'stderr '
   inp8 := StrPos(inp, ' ');
   New(sout);
   sout^ := inp8 + 1;  // skip space
   form := userData;

   if (StrLComp(inp, 'stdout', 6) = 0) then
       PostMessage(Form1.Handle, WM_PRMESSAGE, 0, LPARAM(sout))
   else
      if (StrPos(inp8, 'Reference value') = nil) then
         PostMessage(form.Handle, WM_ERRMESSAGE, 0, LPARAM(sout))
      else
         PostMessage(form.Handle, WM_REFMESSAGE, 0, LPARAM(sout));

   result := 0;
end;

// currently not used
procedure outdata();
var
   sout: PChar;
   pstr: PString;
   inp8: PChar;
   form: TForm1;
   userData: Pointer;
begin
   sout := OUTqueue.Pop;
   userData := OUTqueue.Pop;
   // remove 'stdout ', 'stderr '
   inp8 := StrPos(sout, ' ');
   inp8 := StrNextChar(inp8);
   New(pstr);
   pstr^ := inp8;
   form := userData;

   if (StrLComp(sout, 'stdout', 6) = 0) then
       PostMessage(form.Handle, WM_PRMESSAGE, 0, LPARAM(pstr))
   else
      if (StrPos(inp8, 'Reference value') = nil) then
         PostMessage(form.Handle, WM_ERRMESSAGE, 0, LPARAM(pstr))
      else
         PostMessage(form.Handle, WM_REFMESSAGE, 0, LPARAM(pstr));
   Sleep(0);
   StrDispose(sout);         
end;

// callback function
{  Wrapper around function within TForm1 class, which cannot be called directly
   Address sent to ngspice.dll
   Receives progress information (actual task and percent done)
 }
function ng_getstat(inp: PChar; ident: integer; userData: Pointer): integer; cdecl;
var
   pstr: PString;
begin
   New(pstr);
   pstr^ := inp;
   if(not PostMessage(Form1.Handle, WM_STATMESSAGE, 0, LPARAM(pstr))) then
   begin
      Form1.Label3.Caption := 'Error';
   end;
   Sleep(0);
   result := 0;
end;

// callback function
procedure ng_exit(status: Integer; immediate: boolean; ngquit: boolean;  ident: integer; userData: Pointer); cdecl;
begin
  // We exit as result of a command, but first have to finish
  // the command; so here we can only alert the program to detach,
  // detaching is done after the calling fcn has returned
  will_detach := TRUE;
  coquit := ngquit;
  if (immediate = TRUE) then
  begin
    detach(coquit);
  end;

end;

// callback function
procedure ng_data(vdata: pvecvaluesall; numvecs: integer; ident: integer; userData: Pointer); cdecl;
var
    creal: double;
    cimag: double;
    cscale: double;
    is_scale: boolean;
    is_complex: boolean;
    name: string;
    scalename: string;
    number, vindex: integer;
    intdata: pvecvaluesall;
    i: integer;
    imod: integer;
begin
  // get data from all vectors at a every accepted point during simulation
  // Here we specially look for vector with number vecgetnumber (found
  // in fcn ng_initdata()) and its scale vector
    if vecgetnumber >= 0 then
    begin
      // in the beginning: find the scale vector
      if vecgetscaleno = -1 then
        for i := 0 to numvecs - 1 do
          if vdata.vecsa[i].is_scale then
          begin
            vecgetscaleno := i;
            scalename := vdata.vecsa[vecgetscaleno].name;
            Form1.Edit4.Text := scalename;
            break;
          end;

      intdata := vdata;
      number := intdata.vcount;
      vindex := intdata.vindex;
      creal := intdata.vecsa[vecgetnumber].creal;
      cimag := intdata.vecsa[vecgetnumber].cimag;
      cscale := intdata.vecsa[vecgetscaleno].creal;
      is_scale := intdata.vecsa[vecgetnumber].is_scale;
      is_complex := intdata.vecsa[vecgetnumber].is_complex;
      name := intdata.vecsa[vecgetnumber].name;
      {The following actions cause delays in the background thread.
       It is probably better to just fill a static array with the values, then
       post a message to process the data, and return immediately }
      imod := vindex mod 100;
      if imod = 0 then
      begin
          Form1.Edit1.Text := name;
          Form1.label9.Caption := FormatFloat('#.###E+00',creal);
          Form1.label9.Repaint;
          Form1.label10.Caption := FormatFloat('#.###E+00',cscale);
          Form1.label10.Repaint;
      end;
    end;
end;

// callback function
procedure ng_initdata(vdata: pvecinfoall; ident: integer; userData: Pointer); cdecl;
var
   vname: string;
   vnameng: string;
   vtypeng: string;
   vtitleng: string;
   vdateng: string;
   veccount, i: integer;
begin
  // Get info on all vectors after they have been set up. Called once
  // per access to a new plot in ngspice.
  // Put info into a global variable curvinfoall.
  // Then here we look for a vector with name 'name'
  curvinfoall := vdata;
  vname := Form1.Edit3.Text;  // enter vector name to be assessed
  vnameng := curvinfoall.vname;
  vtitleng := curvinfoall.vtitle;
  vdateng := curvinfoall.vdate;
  vtypeng := curvinfoall.vtype;
  veccount := curvinfoall.vcount;
  vecgetnumber := -1;
  vecgetscaleno := -1;
  // find the given vector
  for i := 0 to veccount - 1 do
  begin
     if CompareText(curvinfoall.vecs[i].vecname, vname) = 0 then //case insensitive
     begin
        vecgetnumber := i;
        Form1.Memo1.Lines.Add('DNote: Vector ' + vname + ' found in plot ' + vtypeng );
        break;
     end;
  end;
  if vecgetnumber = -1 then
  begin
     if vname = '' then
       Form1.Memo2.Lines.Add('DWarning: No vector given for monitoring')
     else
       Form1.Memo2.Lines.Add('DError: Vector ' + vname + ' not found in plot ' + vtypeng );
  end;
end;

// callback function
procedure ng_thread_runs(noruns: boolean; ident: integer; userData: Pointer); cdecl;
begin
// show if background thread is running
   if noruns then
     Form1.Panel2.Color := clgreen
   else
     Form1.Panel2.Color := clred;
   Form1.Panel2.Repaint;
end;

// callback function
function ng_sendvsrc(vval: PDouble; time: double; name: PChar; ident: integer; userData: Pointer): integer; cdecl;
begin
   // just an example of a step in voltage vs time
   if time > 0.005 then
        vval^ := 4.5
    else
        vval^ := 3.5;
    result := 0;
end;

// callback function
function ng_sendisrc(ival: PDouble; time: double; name: PChar; ident: integer; userData: Pointer): integer; cdecl;
begin
   // just an example of a step in current vs time
   if time > 0.002 then
        ival^ := 1.7e-3
    else
        ival^ := 2.8e-3;
    result := 0;
end;

// callback function
function ng_sync(time: double; delta: Pdouble; olddelta: double; redostep: integer; ident: integer; userData: Pointer): integer; cdecl;
begin
//    delta^ := delta^ * 1.1;
    if (time < 2e-3) and (time + delta^ > 2e-3) then
        delta^ := 2e-3 - time;
    result := 0;
end;

// unload ngspice.dll
procedure detach(coquit: boolean);
begin
   if (will_detach) then
   begin
      // special command to stop the printf thread in ngspice.dll
      // necessary only if sharedspice.c is compiled with
      // #undef low_latency
      // ngspice_Com('bg_pstop');
      FreeLibrary(Hdll);
      Hdll := 0;

      @ngspice_Init := nil;
      @ngspice_Com := nil;
      @ngspice_GetVec := nil;
      @ngspice_SendCirc := nil;
      @ngspice_GetCurPlot := nil;
      @ngspice_GetPlotNames := nil;
      @ngspice_GetVecsFromPlot := nil;
      @ngspice_Running := nil;
      @ngspice_Init_Sync := nil;
      @ngspice_SetBkpt := nil;

      if (coquit) then
      begin
         Form1.Memo1.Lines.Add('DNote: ngspice.dll detached');
      end
      else
      begin
         Form1.Memo2.Lines.Add('DError: ngspice.dll detached');
      end;
      will_detach := False;
    end;
end;

// load a ngspice circuit file, read it line by line into
// a char* array and send it to ngspice.dll
procedure TForm1.Button10Click(Sender: TObject);
var
   Filename: string;
   line, s: string;
   firstpath: string;
   finalpath: string;
   circarray: carray;
   ret, i, len: integer;
   hasc: integer;
   runcoms: array[1..2] of string = ('run', 'tran');

begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   firstpath := StartIni.ReadString('Input', 'File', '');
   OpenDialog1.InitialDir := ExtractFilePath(firstpath);

   if OpenDialog1.Execute then           {open file Dialogbox}
      Filename := OpenDialog1.FileName      {read chosen file}
   else
      exit;
   finalpath := ExtractFilePath(Filename);
   ngspice_Com(PChar('set sourcepath = ( . ' + finalpath + ' )'));
   StartIni.WriteString('Input', 'File', Filename);
   Memo3.clear;
   Memo3.Lines.LoadFromFile(Filename);
   len := Memo3.Lines.Count;
   setlength(circarray, len + 1);
   // check for .control section
   // bail out when simulation commands like
   // run, tran, dc, op, ac, pz, disto are found
   hasc := 0;
   for i := 0 to len - 1 do
   begin
      line := TrimLeft(Memo3.Lines.Strings[i]);
//      if (line[1] = '*') then
      if (StartsText('*', line)) then
         Continue;
      s := copy(line, 0, 8);
      if (CompareText(s, '.control') = 0) then
      begin
          inc(hasc);
          Continue;
      end;
      s := copy(line, 0, 5);
      if (CompareText(s, '.endc') = 0) then
      begin
          dec(hasc);
          Continue;
      end;
      if (hasc > 0) then
      begin
         s := copy(line, 0, 2);
         if s in runcoms then
         begin
            Memo2.Lines.Add('DError: command ' + s + ' found in .control section.');
            Memo2.Lines.Add('DError: Load File ignored!');
            exit;
         end;
         s := copy(line, 0, 3);
         if s in runcoms then
         begin
            Memo2.Lines.Add('DError: command ' + s + ' found in .control section.');
            Memo2.Lines.Add('DError: Load File ignored!');
            exit;
         end;
         s := copy(line, 0, 4);
         if s in runcoms then
         begin
            Memo2.Lines.Add('DError: command ' + s + ' found in .control section.');
            Memo2.Lines.Add('DError: Load File ignored!');
            exit;
         end;
         s := copy(line, 0, 5);
         if s in runcoms then
         begin
            Memo2.Lines.Add('DError: command ' + s + ' found in .control section.');
            Memo2.Lines.Add('DError: Load File ignored!');
            exit;
         end;
      end;
   end;

   for i := 0 to len - 1 do
   begin
      line := Memo3.Lines.Strings[i];
      getmem(circarray[i], length(line) + 1);
      StrPCopy(circarray[i], line);
   end;
   circarray[len] := nil; // array end sign
   Panel1.Color := clRed;
   Panel1.Repaint;
   ret := ngspice_SendCirc(@circarray[0]);

   for i := 0 to len - 1 do
   begin
      freemem(circarray[i]);
   end;
   Finalize(circarray);

   if (ret = 1) then
   begin
       detach(coquit);
   end;
   Panel1.Color := clGreen;
   Panel1.Repaint;

end;

// check if background thread is running
procedure TForm1.Button11Click(Sender: TObject);
begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   if ngSpice_Running() then
       Button11.Caption := 'bgT'
   else
      Button11.Caption := 'bgF';
end;

// command 'bg_run' to start ngspice in background
procedure TForm1.Button12Click(Sender: TObject);
var
  ret: integer;
begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

  Panel1.Color:= clRed;
  Panel1.Repaint;
  ret := ngspice_Com('bg_run');
  if (ret = 1) then
    detach(coquit);
  Panel1.Color:= clGreen;
  Panel1.Repaint;
end;

// command 'bg_halt' to start ngspice in background
procedure TForm1.Button13Click(Sender: TObject);
var
  ret: integer;
begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

  Panel1.Color:= clRed;
  Panel1.Repaint;
  ret := ngspice_Com('bg_halt');
  if (ret = 1) then
    detach(coquit);
  Panel1.Color:= clGreen;
  Panel1.Repaint;
end;

// command 'bg_resume' to restart ngspice in background
procedure TForm1.Button14Click(Sender: TObject);
var
  ret: integer;
begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

  Panel1.Color:= clRed;
  Panel1.Repaint;
  ret := ngspice_Com('bg_resume');
  if (ret = 1) then
    detach(coquit);
  Panel1.Color:= clGreen;
  Panel1.Repaint;
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
   Memo1.Clear;
   Memo2.Clear;
   label3.Caption := 'Status                     ';
   label4.Caption := 'Reference value            ';
end;

procedure TForm1.Button16Click(Sender: TObject);
var
   simtime: double;
begin
   simtime := StrToFloat(Editt.Text);
   if simtime > 0 then
       ngSpice_SetBkpt(simtime);
end;

function ThreadFunc(tp: PChar): Integer;
var
  ret : Integer;

begin
   Form1.Panel2.Color := clyellow;
  // ngspice mit eigenem Script starten
   ret := ngspice_Com(tp);
{   if (ret = 1) then
   begin
       detach(coquit);
   end;            }
   Form1.Panel2.Color := clgreen;

   Result := ret;
end;

procedure TForm1.Button17Click(Sender: TObject);
var
  tp: PChar;
  Thread : THandle;

begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   tp := PChar('source ' + StartIni.ReadString('Input', 'File', ''));
  // Thread erzeugen.
  Thread := BeginThread(@ThreadFunc, tp);

  // Thread-Handle schliessen und somit das Thread-Objekt zerstören.
  FileClose(Thread); { *Konvertiert von CloseHandle* }
end;

// ngspice starten mit circarray in tp
function ThreadFunc2(tp: Pointer): Integer;
var
   ret, i: integer;
{   circarray: carray;
   pcircarray: pcarray;
   readstr: PChar;   }

begin
   Form1.Panel2.Color := clYellow;
   Form1.Panel2.Repaint;
   ret := ngspice_SendCirc(tp);
   Form1.Panel2.Color := clGreen;
   Form1.Panel2.Repaint;
{
   // free the memory used by circarray
   pcircarray := pcarray(tp);
//   circarray := pcircarray^;
   i := 0;
   While pcircarray^[i] <> nil do
   begin
      readstr := pcircarray^[i];
      freemem(pcircarray^[i]);
      inc(i);
   end;
   Finalize(pcircarray^);
}
   Result := ret;
end;


{ read a filename, load file into array,
call ngspice in a separate thread  }
procedure TForm1.Button18Click(Sender: TObject);
var
   Filename: string;
   line: string;
   firstpath: string;
   finalpath: string;
   circarray: carray;
   i, len: integer;
   tp: Pointer;
   Thread : THandle;

begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   firstpath := StartIni.ReadString('Input', 'File', '');
   OpenDialog1.InitialDir := ExtractFilePath(firstpath);

   if OpenDialog1.Execute then           {open file Dialogbox}
      Filename := OpenDialog1.FileName      {read chosen file}
   else
      exit;
   finalpath := ExtractFilePath(Filename);
   ngspice_Com(PChar('set sourcepath = ( . ' + finalpath + ' )'));
   Memo3.clear;
   Memo3.Lines.LoadFromFile(Filename);
   len := Memo3.Lines.Count;
   setlength(circarray, len + 1);
   for i := 0 to len - 1 do
   begin
      line := Memo3.Lines.Strings[i];
      getmem(circarray[i], length(line) + 1);
      StrPCopy(circarray[i], line);
   end;
   circarray[len] := nil; // array end sign
   StartIni.WriteString('Input', 'File', Filename);
   tp := @circarray[0];
  // Thread erzeugen.
   Thread := BeginThread(@ThreadFunc2, tp);

   FileClose(Thread); { *Konvertiert von CloseHandle* }

end;

// attach ngspice.dll and initialize ngspice
procedure TForm1.Button1Click(Sender: TObject);
var 
   init_test: integer;
   ng_ident: integer;
   libpath: AnsiString;
   firstpath: String;

begin
   if (is_attached) then
   begin
      Memo2.Lines.Add('DWarning: ngspice.dll is already attached');
      exit;
   end;
   firstpath := StartIni.ReadString('ngspice.dll', 'Path', '');
   firstpath := ExtractFilePath(firstpath);
   if (firstpath = '') then
      firstpath := ExtractFilePath(ParamStr(0));
   OpenDialog2.InitialDir:= firstpath;
   if OpenDialog2.Execute then           {open file Dialogbox}
   begin
      libpath := OpenDialog2.FileName      {read chosen file}
   end
   else
   begin
   // load dll
      libpath := PChar(StartIni.ReadString('ngspice.dll', 'Path', ''))
   end;
   Hdll := LoadLibrary(libpath);
   if (Hdll = 0) then
      // try local directory
      Hdll := LoadLibrary('ngspice.dll');
   if (Hdll <> 0) then
   begin
      @ngspice_Init := GetProcAddress(Hdll, 'ngSpice_Init');
      @ngspice_Com := GetProcAddress(Hdll, 'ngSpice_Command');
      @ngspice_GetVec := GetProcAddress(Hdll, 'ngGet_Vec_Info');
      @ngspice_SendCirc := GetProcAddress(Hdll, 'ngSpice_Circ');
      @ngspice_GetCurPlot := GetProcAddress(Hdll, 'ngSpice_CurPlot');
      @ngspice_GetPlotNames := GetProcAddress(Hdll, 'ngSpice_AllPlots');
      @ngspice_GetVecsFromPlot := GetProcAddress(Hdll, 'ngSpice_AllVecs');
      @ngspice_Running := GetProcAddress(Hdll, 'ngSpice_running');
      @ngspice_Init_Sync := GetProcAddress(Hdll, 'ngSpice_Init_Sync');
      @ngspice_SetBkpt := GetProcAddress(Hdll, 'ngSpice_SetBkpt');
      @ngspice_GetCMPath := GetProcAddress(Hdll, 'ngCM_Input_Path');
      // call initialization
      // send addresses of callback functions, and address of sending object
      init_test := ngspice_Init(@ng_getchar, @ng_getstat, @ng_exit, @ng_data,
                                @ng_initdata, @ng_thread_runs, self);
      if (init_test = 1) then
      begin
        detach(coquit);
      end;
      ng_ident := 5;
      init_test := ngspice_Init_Sync(@ng_sendvsrc, @ng_sendisrc,
                                     @ng_sync {nil} , @ng_ident, self);
      if (init_test = 1) then
      begin
        detach(coquit);
        is_attached := false;
      end;
      will_detach := False;
      is_attached := True;
      StartIni.WriteString('ngspice.dll', 'Path', libpath);
   end
   else
   begin
     MessageDlg('ngspice.dll not found', mtError, [mbAbort], 0);
     Form1.Close;
   end;
end;

// Get a path for files loadable by code models
procedure TForm1.Button19Click(Sender: TObject);
var
   cmfilepath: String;
begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;
   if (@ngspice_GetCMPath = nil) then
   begin
      Memo2.Lines.Add('DError: ngspice_GetCMPath is not available');
      exit;
   end;
//   OpenDialog3.InitialDir:= firstpath;
   if OpenDialog3.Execute then           {open file Dialogbox}
   begin
      cmfilepath := ExtractFilePath(OpenDialog3.FileName);   {read chosen path}
      ngspice_GetCMPath(PChar(cmfilepath));
   end;
end;

// Read a file name from ng_start.ini and send it with preceding
// command 'source' to ngspice.dll
procedure TForm1.Button2Click(Sender: TObject);
var
   comtext: PChar;
   ret: integer;
begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   comtext := PChar('source ' + StartIni.ReadString('Input', 'File', ''));
   ret := ngspice_Com(comtext);
   if (ret = 1) then
   begin
       detach(coquit);
   end;
{   comtext := 'tran 0.05ns 20ns';
   ngspice_Com(comtext);
   comtext := 'wrdata out v(2) V(5)';
   ngspice_Com(comtext);
   comtext := 'print  v(2) V(5)';
   ngspice_Com(comtext);
   comtext := 'display';
   ngspice_Com(comtext);
   comtext := 'gnuplot gp-test  v(2) V(5)';
   ngspice_Com(comtext);  }
end;

// 'Quit' button
procedure TForm1.Button3Click(Sender: TObject);
begin
   StartIni.UpdateFile();
   StartIni.Free;
   if is_attached then
      detach(TRUE);
   Form1.Close;
//   Application.Destroy;
end;

// Find the pointer to a vector with name given as plot.vector
// Then just read the length of the vector as an example
procedure TForm1.Button4Click(Sender: TObject);
var
   number: integer;
   vecptr: pVector_info;
   newvec: string;

begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   newvec := Combobox1.Items[ComboBox1.ItemIndex] +
       '.' + Combobox2.Items[ComboBox2.ItemIndex];
   vecptr := ngspice_GetVec(PChar(newvec));
   if (vecptr = nil) then
   begin
       Label5.Caption := 'vector not found';
       exit;
   end;
   number := vecptr^.v_length;
   Label5.Caption := IntToStr(number);
end;

// detach ngspice.dll from ng_start.exe
procedure TForm1.Button5Click(Sender: TObject);
begin
   will_detach := TRUE;
   detach(TRUE);
   is_attached := False;
   will_detach := FALSE;
end;

// generate a circuit line by line, store it in a dynamic char array,
// and send it to ngspice.dll by fcn ngspice_SendCirc
procedure TForm1.Button6Click(Sender: TObject);
var
   ret, i: Integer;
   circarray: carray;
   newstr: string;

begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   SetLength(circarray, 8);
   newstr := 'titel: circuit via char array';
   getmem(circarray[0], length(newstr) + 1);
   StrPCopy(circarray[0], PChar(newstr));
   newstr := 'V1 1 0 1';
   getmem(circarray[1], length(newstr) + 1);
   StrPCopy(circarray[1], PChar(newstr));
   newstr := 'R1 1 2 1';
   getmem(circarray[2], length(newstr) + 1);
   StrPCopy(circarray[2], PChar(newstr));
   newstr := 'C1 2 0 1 ic=0';  // error
   getmem(circarray[3], length(newstr) + 1);
   StrPCopy(circarray[3], PChar(newstr));
   newstr := '.tran 10u 3 uic';
   getmem(circarray[4], length(newstr) + 1);
   StrPCopy(circarray[4], PChar(newstr));
   newstr := 'V2 11 0 EXTERNAL 2';  // error
   getmem(circarray[5], length(newstr) + 1);
   StrPCopy(circarray[5], PChar(newstr));
   newstr := '.end';
   getmem(circarray[6], length(newstr) + 1);
   StrPCopy(circarray[6], PChar(newstr));
   circarray[7] := nil;
   // see the special description of the array pointer !!
   ret := ngspice_SendCirc(@circarray[0]);
   if (ret = 1 ) then
   begin
     detach(coquit)
   end;
   for i := 0 to 6 do
     freemem(circarray[i]);
   Finalize(circarray);

end;


// get name of current plot
procedure TForm1.Button7Click(Sender: TObject);
begin
   if (@ngspice_GetCurPlot = nil) then
   begin
      Memo2.Lines.Add('DError: no initialization');
      exit;
   end
   else
      Label6.Caption := ngspice_GetCurPlot();
end;

// given a plot name, all vector names are received
procedure TForm1.Button8Click(Sender: TObject);
var
   plotname: string;
   pveclist: ppansichararray;
   i: integer;
begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   plotname := Combobox1.Items[ComboBox1.ItemIndex];
   pveclist := ngspice_GetVecsFromPlot(PChar(plotname));
   if (pveclist = nil) then
   begin
      Memo2.Lines.Add('DError: no vectors in plot');
      exit;
   end;
   
   i := 0;
   Combobox2.Clear;
   while (pveclist^[i] <> nil) do
   begin
      Combobox2.Items.Add(pveclist^[i]);
      inc(i);
   end;
   Combobox2.Text := Combobox2.Items.Strings[0];
   Combobox2.ItemIndex := 0;
end;

// all plot names are received
procedure TForm1.Button9Click(Sender: TObject);
var
   pplotlist: ppansichararray;
   i: integer;
begin
   if not is_attached then
   begin
      Memo2.Lines.Add('DError: ngspice not attached');
      exit;
   end;

   pplotlist := ngspice_GetPlotNames();
   if (pplotlist = nil) then
   begin
      Memo2.Lines.Add('DError: no plots availble so far');
      exit;
   end;
   ComboBox1.clear;
   i := 0;
   while (pplotlist^[i] <> nil) do
   begin
      ComboBox1.Items.Add(pplotlist^[i]);
      inc(i);
   end;
   Combobox1.SelText := ComboBox1.Items.Strings[0];
   ComboBox1.ItemIndex := 0;
end;

// enter a command or select a command from combo box  and send
// it to ngspice.dll
// If ngspice is not loaded, command is stored in CoboBox, but
// then the procedure is exited immediately.
procedure TForm1.ComboBox3KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   comtext: PChar;
   ret: integer;
   input: string;
begin
   if (Key = VK_RETURN) then
   begin
      ret := 0;
      Panel1.Color:= clRed;
      Panel1.Repaint;
      input := ComboBox3.Text;
      Combobox3.Items.Add(input);
      if ComboBox3.ItemIndex = -1 then
         comtext := PChar(input)
      else
         comtext := PChar(ComboBox3.Items[ComboBox3.ItemIndex]);

      if not is_attached then
         Memo2.Lines.Add('DError: ngspice not attached')
      else
         ret := ngspice_Com(comtext);

      if (ret = 1) then
         detach(coquit);
      ComboBox3.Text := '';
      Panel1.Color:= clGreen;
      Panel1.Repaint;
   end;
end;

// create ini file upon startup, if not already there
procedure TForm1.FormCreate(Sender: TObject);
begin
  PrintList := TStringList.Create;
  Outqueue := TQueue.Create;
  is_attached := false;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   Startpath := ExtractFilePath(ParamStr(0));
   if (StartIni = nil) then
      StartIni := TMEMIniFile.Create(Startpath + '\ng_start64.ini');
   mainthreadid := GetCurrentThreadId();

   Application.HintHidePause := 10000; {Show all hints for 10 seconds}

   Button17.Hint := 'Source the input file as defined in ng_start.ini in its own thread.'
            + #10#13 + 'Useful only if file contains .control script'
            + #10#13 + 'starting simulation and including ''quit''.';
   Button17.ShowHint := True;

   Button18.Hint := 'Load an input file, transfer it to ngspice in its own thread.'
            + #10#13 + 'Useful only if file contains .control script'
            + #10#13 + 'starting simulation and including ''quit''.';
   Button18.ShowHint := True;

   Button2.Hint := 'Source the input file as defined in ng_start.ini.'
            + #10#13 + 'Useful if file contains only the circuit description,'
            + ' but no .control script.'
            + #10#13 + 'To be started with bg_run.';
   Button2.ShowHint := True;

   Button10.Hint := 'Load an input file, transfer it to ngspice.'
            + #10#13 + 'Useful if file contains only the circuit description,'
            + ' but no .control script.'
            + #10#13 + 'To be started with bg_run.';
   Button10.ShowHint := True;

   Button6.Hint := 'Load an internally defined simple RC circuit, transfer by array.'
            + #10#13 + 'To be started with bg_run.';
   Button6.ShowHint := True;
end;

// To receive this custom Message that is addressed to form1.handle
// you need a message handler.

// handler for printf to stdout
procedure TForm1.OnPrint(var Msg: TMessage);
var
    inchars: PString;
begin
    inchars := PString(Msg.lParam);
    Memo1.Lines.Add(inchars^);
    Dispose(inchars);
end;

// handler for printf to stderr
procedure TForm1.OnErrPrint(var Msg: TMessage);
var
    inchars: PString;
begin
    inchars := PString(Msg.lParam);
    Memo2.Lines.Add(inchars^);
    Dispose(inchars);
end;

// handler for printf of the reference values
procedure TForm1.OnRefPrint(var Msg: TMessage);
var
    inchars: PString;
begin
    inchars := PString(Msg.lParam);
    Label4.Caption := inchars^;
    Label4.Repaint;
    Dispose(inchars);
end;

// handler for printf of the status message
procedure TForm1.OnStatPrint(var Msg: TMessage);
var
    inchars: PString;
begin
    inchars := PString(Msg.lParam);
    Label3.Caption := '                      ';
    Label3.Caption := inchars^;
    Label3.Repaint;
    Dispose(inchars);
end;

end.
